﻿/* Skript zur Demonstration von LOG_ERRORS-Klausel
 * Als Benutzer SCOTT ausführen
 */

 -- LOG ERROR-Tabelle erstellen (optional)
call dbms_errlog.create_error_log('EMP', 'EMP_ERR');

-- ERstellt Tabelle beschreiben
desc emp_err;

-- Anweisung, die Fehler erzeugen wird
insert into emp (empno, ename, job, deptno)
-- EMPNO existiert bereits
select 7839, 'PETERS', 'ANALYST', 10 from dual 
union all
-- ENAME zu lang
select 8200, 'LAHMAR-SCHADLER', 'MANAGER', 20 
  from dual union all
-- DEPTNO existiert nicht
select 8300, 'MÜLLER', 'CLERK', 70 from dual
log errors into emp_err ('Testlauf') reject limit 10;


-- Anzeige der Grenzen für REJECT LIMIT
insert into emp (empno, ename, job, deptno) 
select 7839, 'PETERS', 'ANALYST', 10 from dual 
log errors into emp_err ('Testlauf') 
reject limit 1000000000000000;


-- Abfrage der Fehlerergebnisse
select ora_err_number$ err_no, 
       ora_err_mesg$, 
       ora_err_tag$ ora_tag$, 
       ename
  from emp_err;
