﻿/* Skript zur Erzeugung von Tabellen
 * Als Benutzer SCOTT ausführen
 */

-- Erstellung einer einfachen Tabelle
create table emp_test(
  emp_id number(5,0),
  last_name varchar2(25 char),
  first_name varchar2(25 char),
  department_id number,
  hire_date date,
  e_mail varchar2(50 char)
);


drop table emp_test;

-- Eine Fassung mit Constraints
create table emp_test(
  emp_id number(5,0)
    constraint emp_pk primary key,
  last_name varchar2(25 char) not null,
  first_name varchar2(25 char) not null,
  department_id number,
  hire_date date,
  e_mail varchar2(50 char) 
    constraint emp_chk_email check (instr(e_mail, '@') > 0),
  constraint emp_dept_fk foreign key (department_id)
    references dept (deptno)
);

 