-- Einfhrung in die Rechteverwaltung, als Benutzer SYSTEM ausfhren
-- Benutzer mit Passwort erzeugen
create user test_user identified by pwd_4_test;

-- Recht, sich mit der Datenbank zu verbinden, einrumen
grant create session to test_user;

-- Benutzer darf sich anmelden:
connect test_user/pwd_4_test;

-- und auch bereits Objekte verwenden, deren Verwendung ffentlich ist:
select object_type, count(*) 
  from all_objects 
 group by object_type;

 
connect system;

-- Recht, Tabellen anzulegen, einrumen
grant create table to test_user;

connect test_user/pwd_4_test;

-- Das Recht kann genutzt werden:
create table my_first_table(
  id number, 
  description varchar2(50 char));
  
-- Allerdings drfen keine Daten eingefgt werden, weil kein Plattenplatz allokiert werden darf
insert into my_first_table
values(1, 'My first row!');

connect system;

-- Daher muss dieses Recht zugeordnet und ein Default-Tablespace festgelegt werden
alter user test_user default tablespace example;
alter user test_user quota 20M on users;

-- Danach gelingt das Einfgen von Daten
connect test_user;

insert into my_first_table
values(1, 'My first row!');

commit;

-- Abfrage von Systemprivilegien
select * 
  from dba_sys_privs 
 where grantee in ('DBA', 'SYSTEM');

-- Programmierung einer Prozedur, um Rechte an einen Benutzer zu erteilen:
declare 
  cursor tables is 
    select table_name 
	  from user_tables; 
begin 
  for tbl in tables loop 
    execute immediate 'grant select on ' || tbl.table_name || ' to test_user'; 
  end loop;
end;
/

-- Objektprivilegien erteilen
grant update (ename, job) on emp to willi;

-- ... und entziehen:
revoke all on emp from test_user;

-- Rollen erzeugen und verwenden
create role user_role;

-- Objektprivileg an Rolle erteilen
grant create session to user_role; 
grant select on emp to user_role;

-- Rolle an User erteilen
grant user_role to test_user;

-- Rolle an Rolle erteilen
grant hire_emp_role to user_role;

-- Rolle von Benutzer entziehen
revoke user_role from test_user; 

-- Rolle lschen
drop role user_role;
