-- Beispiel: Erkennen zusammengehrender Intervalle

-- Testtabelle und Daten erzeugen
create table range_test(
  range_id number,
  range_from date,
  range_to date);

insert into range_test(range_id, range_from, range_to)
select 123, timestamp '2015-02-02 15:30:00', timestamp '2015-02-02 23:59:59' from dual union all
select 123, timestamp '2015-02-03 00:00:00', timestamp '2015-02-03 23:59:59' from dual union all
select 123, timestamp '2015-02-04 00:00:00', timestamp '2015-02-04 17:30:00' from dual union all
select 123, timestamp '2015-02-05 09:25:00', timestamp '2015-02-05 23:59:59' from dual union all
select 123, timestamp '2015-02-06 00:00:00', timestamp '2015-02-06 23:59:59' from dual union all
select 123, timestamp '2015-02-07 00:00:00', timestamp '2015-02-07 17:22:15' from dual union all
select 234, timestamp '2015-02-06 19:45:00', timestamp '2015-02-06 23:59:59' from dual union all
select 234, timestamp '2015-02-07 00:00:00', timestamp '2015-02-07 23:59:59' from dual union all
select 234, timestamp '2015-02-08 00:00:00', timestamp '2015-02-08 07:50:33' from dual;

commit;

-- Abfrage zum Verbinden der Intervalle
 select level, range_id,  
        connect_by_root(range_from) total_from,  
 	    case connect_by_isleaf when 1 then range_to end total_to 
   from range_test r 
  start with range_from - trunc(range_from) > 0 
connect by prior range_id = range_id 
    and prior range_to + interval '1' second = range_from;

-- Komplette Abfrage
select range_id, 
       total_from, 
	   max(total_to) total_to 
  from ( select level, range_id,  
				connect_by_root(range_from) total_from,  
				case connect_by_isleaf when 1 then range_to end total_to 
		   from range_test r 
		  start with range_from - trunc(range_from) > 0 
		connect by prior range_id = range_id 
			and prior range_to + interval '1' second = range_from)
 group by range_id, total_from;

