-- Konvertierung von Datum in Zeichenketten
-- Bercksichtigung des Parameters NLS_PARAM
select to_char(sysdate, 'Day') deutsch, 
       to_char(sysdate, 'Day', 
	   'nls_date_language=AMERICAN') englisch 
  from dual;

/* Zeilenfunktionen zur Bearbeitung von Zeitzonen */
-- DBTIMEZONE, SESSIONTIMEZONE
select dbtimezone, sessiontimezone
  from dual;
  
-- FROM_TZ zur berfhrung von timestamp in timestamp with time zone
select from_tz(localtimestamp, 'America/Chicago') ts_with_tz
  from dual;
select from_tz(localtimestamp, '-07:30') ts_with_tz
  from dual;
  
-- NEW_TIME zur berfhrung eines Datums in eine andere Zeitzone (liefert date)
select localtimestamp,
       new_time(localtimestamp, 'GMT', 'EST') new_date
  from dual;

select sysdate,
       new_time(sysdate, 'GMT', 'EST') new_date
  from dual;
  
-- SYS_EXTRACT_UTC zur Extraktion von UTC aus timestamp with time zone
select sys_extract_utc(
         timestamp '2012-05-15 15:30:00 America/Chicago') utc_time
  from dual;
  
-- TZ_OFFSET Differenz zu UTC
select tz_offset('US/Eastern') offset
  from dual;
  
select tz_offset(dbtimezone) offset
  from dual;
  
select tz_offset(sessiontimezone) offset
  from dual;
  
select tz_offset('UTC') offset
  from dual;
