﻿/* Skript zur Demonstration von XML
 * Als Benutzer SCOTT ausführen
 */
 
-- Schrittweise Erzeugung einer XML-Instanz
select xmlelement("Mitarbeiter") resultat
  from emp;

-- Zweiter Schritt: Ergänzung von Attributen
select xmlelement("Mitarbeiter",
         xmlattributes(
           hiredate "einstellDatum",
           empno "id"
         )
       ) resultat
  from emp;
  
-- Dritter Schritt: Ergänzung von Kindelementen
select xmlelement("Mitarbeiter",
         xmlattributes(
           hiredate "einstellDatum",
           empno "id"
         ),
         xmlforest(
           initcap(ename) "Name",
           initcap(job) "Beruf",
           trim(to_char(sal, '999G990D00L')) "Gehalt"
         )
       ) resultat
  from emp;

-- Vierter Schritt: Einkapselung in ein Wurzelelement
select xmlelement("Mitarbeiterliste",
         xmlelement("Mitarbeiter",
           xmlattributes(
             hiredate "einstellDatum",
             empno "id"
           ),
           xmlforest(
             initcap(ename) "Name",
             initcap(job) "Beruf",
             trim(to_char(sal, '999G990D00L')) "Gehalt"
           )
         ) 
       ) resultat
  from emp;
  
-- Fünfter Schritt: Gruppenfunktion
select xmlelement("Mitarbeiterliste",
         xmlagg(
           xmlelement("Mitarbeiter",
             xmlattributes(
               hiredate "einstellDatum",
               empno "id"
             ),
             xmlforest(
               initcap(ename) "Name",
               initcap(job) "Beruf",
               trim(to_char(sal, '999G990D00L')) "Gehalt"
             )
           )
         ) 
       ) resultat
  from emp;
  
-- Letzter Schritt: Gruppierung nach Abteilung

  
-- Fünfter Schritt: Gruppenfunktion
select xmlelement("Mitarbeiterliste",
         xmlattributes(
           deptno "abteilung"
         ),
         xmlagg(
           xmlelement("Mitarbeiter",
             xmlattributes(
               hiredate "einstellDatum",
               empno "id"
             ),
             xmlforest(
               initcap(ename) "Name",
               initcap(job) "Beruf",
               trim(to_char(sal, '999G990D00L')) "Gehalt"
             )
           )
         ) 
       ) resultat
  from emp
 group by deptno;
 
-- Ausgabe mittels XMLSerialize (Einrückung)
select xmlserialize(
         document 
         xmlelement("Mitarbeiterliste",
           xmlattributes(
             deptno "abteilung"
           ),
           xmlagg(
             xmlelement("Mitarbeiter",
               xmlattributes(
                 hiredate "einstellDatum",
                 empno "id"
               ),
               xmlforest(
                 initcap(ename) "Name",
                 initcap(job) "Beruf",
                 trim(to_char(sal, '999G990D00L')) "Gehalt"
               )
             )
           ) 
         ) as clob
         indent size = 3 
       ) resultat
  from emp
 group by deptno;
 