-- Arbeiten mit XML Schema in der Datenbank
-- Registrieren eines Schemas
begin 
  dbms_xmlschema.registerschema( 
    schemaURL => 'www.rheinwerk-verlag.de/PL/SQL/schema/Adresse', 
	schemaDoc => xdburitype( '/public/scott/xsd/Adresse.xsd').getclob(), 
	local => true, 
	genTypes => false, 
	genBean => false, 
	genTables => false, 
	options => dbms_xmlschema.REGISTER_BINARYXML);
end; 
/

-- Tabelle auf dem Schema erzeugen
create table employees(
  empno number, 
  ename varchar2(30 char), 
  address XMLType) 
  XMLType address store as binary xml
  XMLSchema "www.rheinwerk-verlag.de/PL/SQL/schema/Adresse" 
  element "Adresse";
 
-- Versuch, nicht valide Daten einzufgen
insert into employees 
select empno, ename, 
       XMLType('<?xml version="1.0" encoding="UTF-8"?> 
	             <Adresse id="7369"> 
			     <Strasse>Hauptstrasse 5</Strasse> 
			     <PLZ>12345</PLZ> 
			     <Ort>Wohndorf</Ort> 
			     <Land>D</Land> 
			    </Adresse>') 
  from emp 
 where empno = 7369; 

-- Mit Namensraum gelingt das Einfgen
insert into employees 
select empno, ename, 
       XMLType('<?xml version="1.0" encoding="UTF-8"?> 
	             <Adresse id="7369" xmlns="www.rheinwerk-verlag.de/PL/SQL/schema/Adresse"> 
			     <Strasse>Hauptstrasse 5</Strasse> 
			     <PLZ>12345</PLZ> 
			     <Ort>Wohndorf</Ort> 
			     <Land>D</Land> 
			    </Adresse>') 
  from emp 
 where empno = 7369;

-- Ohne PLZ misslingt das Einfgen
insert into employees 
select empno, ename, 
       XMLType('<?xml version="1.0" encoding="UTF-8"?> 
	             <Adresse id="7369" xmlns="www.rheinwerk-verlag.de/PL/SQL/schema/Adresse"> 
			     <Strasse>Hauptstrasse 5</Strasse> 
			     <Ort>Wohndorf</Ort> 
			     <Land>D</Land> 
			    </Adresse>') 
  from emp 
 where empno = 7369;

