-- Analyse auf die SALES-Tabelle
-- Verwendung der Klausel ONE ROW/ALL ROWS per match
  with prods as(
       select prod_id, sum(quantity_sold) quantity
         from sales
         group by prod_id)
select prod_group, prod_id, prod_running_sum, final_sum
  from prods
 match_recognize(
       order by prod_id
       measures
         match_number() prod_group,
         sum(quantity) prod_running_sum,
         final sum(quantity) final_sum
       all rows per match
       pattern(gr*)
       define
         gr as sum(quantity) < 100000
       );

	   
-- Analyse der Tabelle TICKER
select *
  from ticker
 match_recognize(
       partition by symbol
       order by tstamp
       measures
         first(strt.tstamp) as strt_time,
         last(down.tstamp) as bottom,
         avg(stdn.price) as stdn_avgprice
       one row per match
       after match skip to last up
       pattern (strt down+ up+)
       subset stdn = (strt, down)
       define
         up as up.price > prev(up.price),
         down as down.price < prev (down.price)
);
