-- Beispiel Ticketverwaltung
-- Tabelle erstellen
create table ticket_progress(
  ticket_id number,
  assignee varchar2(30),
  assign_date date);
  
-- Daten einfgen
insert into ticket_progress(ticket_id, assignee, assign_date)
select 1, 'SCOTT', to_date('01.02.2015', 'dd.mm.yyyy') from dual union all
select 1, 'SCOTT', to_date('02.02.2015', 'dd.mm.yyyy') from dual union all
select 1, 'ADAMS', to_date('03.02.2015', 'dd.mm.yyyy') from dual union all
select 1, 'SCOTT', to_date('04.02.2015', 'dd.mm.yyyy') from dual union all
select 2, 'ADAMS', to_date('01.02.2015', 'dd.mm.yyyy') from dual union all
select 2, 'ADAMS', to_date('02.02.2015', 'dd.mm.yyyy') from dual union all
select 2, 'SCOTT', to_date('03.02.2015', 'dd.mm.yyyy') from dual union all
select 3, 'KING', to_date('01.02.2015', 'dd.mm.yyyy') from dual union all
select 3, 'ADAMS', to_date('02.02.2015', 'dd.mm.yyyy') from dual union all
select 3, 'ADAMS', to_date('03.02.2015', 'dd.mm.yyyy') from dual union all
select 3, 'KING', to_date('04.02.2015', 'dd.mm.yyyy') from dual union all
select 3, 'ADAMS', to_date('05.02.2015', 'dd.mm.yyyy') from dual union all
select 4, 'KING', to_date('01.02.2015', 'dd.mm.yyyy') from dual union all
select 4, 'ADAMS', to_date('02.02.2015', 'dd.mm.yyyy') from dual union all
select 4, 'SCOTT', to_date('03.02.2015', 'dd.mm.yyyy') from dual union all
select 4, 'KING', to_date('04.02.2015', 'dd.mm.yyyy') from dual;

commit;

-- Pattern Abfragen
select ticket_id, assignee, last_date
  from ticket_progress
 match_recognize(
       partition by ticket_id
       order by assign_date
       measures
         strt.assignee as first_assignee,
         last(same.assign_date) as last_date
       pattern(strt another+ same+)
       define
         same as same.assignee = strt.assignee,
         another as another.assignee != strt.assignee
);

-- Mit Klausel AFTER MATCH SKIP TO
select *
  from ticket_progress
 match_recognize(
       partition by ticket_id
       order by assign_date
       measures
         strt.assignee as first_assignee,
         last(same.assign_date) as last_date
       after match skip to first another
       pattern(strt another+ same+)
       define
         same as same.assignee = strt.assignee,
         another as another.assignee != strt.assignee
);
