-- Deklaration eines VARRAY
create type Telefon_Array as
  varray(3) OF varchar2(20);
/

-- Verwendung mit Konstruktormethode
select telefon_array(
         '+49-1234-5678', '+49-2345-7896-15')
  from dual;

-- Fehlerhafter Versuch, auf Elemente eines VARRAY zuzugreifen
with telefonliste as(
        select telefon_array(
                 '+49-1234-5678', 
                 '+49-2345-7896-15') telefon
          from dual)
select t.telefon(2)
  from telefonliste t;

-- Erste Annherung: Gesamtes VARRAY anzeigen
with telefonliste as(
        select telefon_array(
                 '+49-1234-5678',
                 '+49-2345-7896-15') telefon
          from dual)
select t.telefon
  from telefonliste t;

-- Verwendung der Funktion TABLE, um das Objekt zu entschachteln
select *
  from table(select telefon_array(
                 '+49-1234-5678',
                 '+49-2345-7896-15') telefon
          from dual);

