-- Regel: Sagen Sie der Datenbank, was Sie wollen!
-- Top-N-Analyse, schlecht gemacht:
select ename, job, sal
  from emp
 order by sal desc;
 
-- Besser:
select ename, job, sal 
 from (select ename, job, sal
         rank() over (order by sal desc) rang
		 from emp)
 where rang <= 5;
 
-- Ab Version 12c:
select ename, job, sal
  from emp
 order by sal desc
 fetch first 5 row with ties;

-- Regel 2: Nutzen Sie SQL bis zur Neige!
-- Schlechtes Beispiel: Komplexer Bericht mit Standard SQL
select e1.deptno, e1.ename, e1.sal,
       sum(e4.sal) cum_sal,
       round(100 * e1.sal/e2.sal_by_dept, 1) pct_dept,
       round(100 * e1.sal/e3.sal_overall, 1) pct_overall
  from emp e1
  join (select deptno, sum(sal) sal_by_dept
          from emp
         group by deptno) e2
    on e1.deptno = e2.deptno
 cross join (
       select sum(sal) sal_overall
         from emp) e3
  join emp e4
    on (e1.deptno = e4.deptno
   and (e1.sal > e4.sal
    or (e1.sal = e4.sal and e1.ename >= e4.ename)))
 group by e1.deptno, e1.ename, e1.sal,
       round(100 * e1.sal/e2.sal_by_dept, 1),
       round(100 * e1.sal/e3.sal_overall, 1)
 order by e1.deptno, e1.sal, e1.ename;

-- Besser: Verwendung analytischer Funktionen
select deptno, ename, sal,
       sum(sal) over
         (partition by deptno order by sal, ename) cum_sal,
       round(ratio_to_report(sal) over
         (partition by deptno) * 100, 1) pct_dept,
       round(ratio_to_report(sal) over () * 100, 1) pct_overall
  from emp
 order by deptno, sal, ename;
