-- Vermeidung von Umgebungswechseln
-- Funktionsaufrufe in SQL
select *
  from emp
 where deptno = v('P10_DEPTNO');
 
-- Besser: Kapselung des Aufrufs in einer skalaren Unterabfrage
select *
  from emp
 where deptno = (select v('P10_DEPTNO') from dual);
 
-- Kapselung mehrerer Parameterwerte in einer Inner VIEW
  with params as(
       select v('P10_DEPTNO') deptno,
              v(('P10_JOB') job
         from dual)
select e.*
  from emp e natural join params p;

-- Vermeidung von Zeilentriggern
create or replace trigger trg_emp_briu
before insert or update on emp
for each row
declare
  l_now date := sysdate;
begin
  :new.empno := coalesce(:new.empno, emp_seq.nextval);
  :new.ename := upper(:new.ename);
  if updating then
    :new.empno := :old.empno;
  end if;
end;
/
