-- CLOSURE TABLE
-- Erzeugung einer Closure-Tabelle aus der bestehenden Tabelle EMP
drop table hierarchy_closure;
create table hierarchy_closure as
select h.ename mitarbeiter, e.ename vorgaenger
  from emp e
  join ( select ename, sys_connect_by_path(ename, '|') pfad
           from emp
          start with mgr is null
        connect by prior empno = mgr) h
    on instr(h.pfad, e.ename) > 0;
    
-- Eintrge des Mitarbeiters ADAMS
select *
  from hierarchy_closure
 where mitarbeiter = 'ADAMS';
    
-- Einen neuen Mitarbeiter einfgen
insert into hierarchy_closure
select 'WILLIAMS', vorgaenger
  from hierarchy_closure
 where mitarbeiter = 'SCOTT' 
union all
select 'WILLIAMS', 'WILLIAMS' from dual;

select *
  from hierarchy_closure
 where mitarbeiter = 'WILLIAMS';
    
-- Umhngen eines Teilbaums
delete
  from hierarchy_closure
 where vorgaenger in (
       select vorgaenger
         from hierarchy_closure
        where mitarbeiter = 'SCOTT')
   and mitarbeiter in (
       select mitarbeiter
         from hierarchy_closure
        where vorgaenger = 'SCOTT'
          and mitarbeiter != vorgaenger);

-- Insert-Abfrage zum Einfgen neuer Daten in den Baum         
select v.mitarbeiter, n.vorgaenger
  from hierarchy_closure v
 cross join
       hierarchy_closure n
 where v.vorgaenger = 'SCOTT'
   and n.mitarbeiter = 'MARTIN';