/* Skripte zur Auswahl von Spalten: Projektion
 * Auszufuehren als Benutzer SCOTT
 */

-- einfachst moegliche SQL-Anweisung
select *
  from emp;
  
-- einfache Spaltenauswahl
select ename, job, sal
  from emp;
  
-- Spalten mehrfach auswaehlen
select job, ename, job, sal, sal
  from emp;
  
-- Berechnung des neuen Gehalts
select ename, job, sal, sal * 1.03
  from emp;
  
-- Zeichenketten konkatenieren
select ename || job
  from emp;
  
-- Zeichenketten mit Leerzeichen konkatenieren
select ename || ' ' || job
  from emp;
  
-- Ausgabe einer konstanten Zeichenkette
select 'Willi hat Durst!', 17
  from emp;
  
-- Verwendung der Konkatenationsfunktion
select 'cp C:\my_files\' || job || '\' || ename || '.txt' || ' E:\ files\' || job || '\' || ename || '.txt '
  from emp;

-- Verwendung der Tabelle DUAL
select sysdate
  from dual;
  
-- ein einfaches Alias verwenden
select ename mitarbeiter, job beruf
  from emp;
  
-- Spaltenalias mit dem Schluesselwort AS und Maskierung einer Formel
select ename as mitarbeiter, (12*sal) as jahresgehalt
  from emp;
  
-- Spaltenalias mit Sonderzeichen
select ename as "Mitarbeiter", (12*sal) as "Gehalt/Jahr"
  from emp;
  
-- Spaltenlias mit Tabellenalias
select e.ename as mitarbeiter, (12 * e.sal) as jahresgehalt
  from emp e;

-- Falsche Berechnung des Jahresgehaltes
select ename mitarbeiter,
       (12 * sal ) + comm jahresgehalt
  from emp;
  
-- Korrigierte Berechnung des Jahresgehaltes
select ename mitarbeiter,
       (12 * sal ) + nvl(comm, 120) jahresgehalt
  from emp;
  
 