-- Weiterführende Joinkonzepte
-- Partitionierter Join (als Benutzer SH ausführen!)
-- Rohdaten:
select p.prod_name, t.time_id, count(*) amount_sold 
  from sales s
  join products p on s.prod_id = p.prod_id 
  join times t on s.time_id = t.time_id 
 where t.calendar_month_desc in ('2000-01') 
   and p.prod_name in (
          'Comic Book Heroes',
		  'CD-R Mini Discs',
		  'Envoy 256MB - 40GB')
 group by p.prod_name, t.time_id 
 order by p.prod_name, t.time_id;

-- Nachweis, dass Zeilen nicht geliefert werden:
  with prod_sales as (
       select s.time_id, p.prod_name, count(*) amount_sold 
	     from sales s 
		 join products p on s.prod_id = p.prod_id
		where prod_name in ('Comic Book Heroes', 'CD-R Mini Discs', 'Envoy 256MB - 40GB')
		group by s.time_id, p.prod_name)
select t.time_id, p.prod_name, 
       coalesce(p.amount_sold, 0) amount_sold 
  from times t 
  left join prod_sales p on t.time_id = p.time_id 
 where t.calendar_year = 2000
   and t.calendar_week_number = 4
 order by p.prod_name, t.time_id;

-- Partitionierter Join zur Lösung des Problems:
  with prod_sales as (
       select s.time_id, p.prod_name, count(*) amount_sold 
	     from sales s 
		 join products p on s.prod_id = p.prod_id
		where prod_name in ('Comic Book Heroes', 'CD-R Mini Discs', 'Envoy 256MB - 40GB')
		group by s.time_id, p.prod_name)
select t.time_id, p.prod_name, 
       coalesce(p.amount_sold, 0) amount_sold 
  from times t 
  left join prod_sales p partition by (p.prod_name)
    on t.time_id = p.time_id 
 where t.calendar_year = 2000
   and t.calendar_week_number = 4
 order by p.prod_name, t.time_id;

-- CROSS APPLY
-- Problem: Tabelle kann nicht aus Inner View referenziert werden
select *
  from dept d
 cross join (
       select *
         from emp e
        where e.deptno = d.deptno);


-- Dies geht mit cross apply
select *
  from dept d
 cross apply (
       select *
         from emp e
        where e.deptno = d.deptno);