﻿/* Skript zur Demonstration von Gruppenfunktionen
 * Als Benutzer SCOTT ausführen
 */
 
  
-- Verwendung mehrerer Gruppenfunktionen in einer Abfrage
select min(sal) min_sal, 
       max(sal) max_sal,
       round(avg(sal), 1) avg_sal,
       sum(sal) sum_sal,
       count(sal) cnt
  from emp;
  
-- Verwendung der Funktion MEDIAN, VARIANCE und STDDEV
select median(empno), variance(empno), stddev(empno)
  from emp;
  
  
-- Verwendung der Funktion AVG mit NULL
select avg(mgr)
  from emp;
  
-- Die Verwendung der Funktion COUNT mit unterschiedlich vielen NULL-Werten
select count(*), count(mgr), count(comm)
  from emp;
  
-- Verwendung der Funktion AVG mit einem Ersatzwert für NULL
select avg(nvl(mgr, 0))
  from emp;

  
-- Die Funktionen AVG und MEDIAN im Vergleich
select round(avg(mgr)) avg_null,
       avg(nvl(mgr, 0)) avg,
       median(mgr) median_null,
       median(nvl(mgr, 0)) median
  from emp;
  
-- Verwendung der distinct-Klausel in Gruppenfunktionen
select count(distinct job) berufe
  from emp;
  
-- Synonym: unique-Klausel
select count(unique job) berufe
  from emp;
  
-- Verwendung der GROUP BY-Klausel
select deptno,
       min(sal) min_sal,
       max(sal) max_sal,
       sum(sal) sum_sal
  from emp
 group by deptno;
 
-- Gruppierung über einen NULL-Wert
select trunc(comm, -3) comm_group, count(*) amount
  from emp
 group by trunc(comm, -3);

-- Auswertung nach DEPTNO und JOB
select deptno, job, 
       min(sal) min_sal,
       max(sal) max_sal,
       sum(sal) sum_sal
  from emp
 group by deptno, job
 order by deptno, job;
 
-- Test: Ist die Reihenfolge der GROUP BY-Klausel relevant?
select deptno, job, 
       min(sal) min_sal,
       max(sal) max_sal,
       sum(sal) sum_sal
  from emp
 group by job, deptno
 order by deptno, job;
 
-- Erweiterung um Abteilung 40
select d.deptno, e.job, 
       min(sal) min_sal,
       max(sal) max_sal,
       sum(sal) sum_sal,
       count(e.deptno) anzahl
  from emp e
  right join dept d on e.deptno = d.deptno
 group by d.deptno, e.job
 order by d.deptno, e.job;

-- Filterung von Gruppenfunktionen mit HAVING
select deptno, min(sal), max(sal), sum(sal)
  from emp
 group by deptno
 order by deptno;
 
select deptno, min(sal), max(sal), sum(sal)
  from emp
 where deptno != 10
 group by deptno
having sum(sal) < 10000
 order by deptno;
 
 