-- Erweiterung der GROUP BY-Klausel durch ROLLUP
select deptno, job, 
       min(sal) min_sal,
       max(sal) max_sal,
       sum(sal) sum_sal,
       count(empno) anzahl
  from emp e
 group by rollup(deptno, job)
 order by deptno, job;
  
-- Erweiterung der GROUP BY-Klausel durch CUBE
select deptno, job, 
       min(sal) min_sal,
       max(sal) max_sal,
       sum(sal) sum_sal,
       count(empno) anzahl
  from emp e
 group by cube(deptno, job)
 order by deptno, job;

-- Verfeinerung der Ausgabe durch GROUPING
select case grouping(d.dname)
       when 1 then 'Alle Abteilungen'
       else d.dname end abteilung,
       case grouping(e.job)
       when 1 then 'Alle Berufe'
       else e.job end beruf,
       grouping(d.dname) dept_group,
       grouping(e.job) job_group,
       sum(e.sal) summe
  from dept d
  join emp e on d.deptno = e.deptno
 group by cube(d.dname, e.job);