-- Spezielle Gruppenfunktionen
-- Verwendung der Funktion RANK und DENSE_RANK
select rank(1600) within group 
         (order by sal desc) rang,
       dense_rank(1600) within group 
         (order by sal desc) dense_rang
  from emp;

-- Darstellung der Mitarbeiter nach Gehalt
select ename, job, sal
  from emp
 order by sal desc;
 
select deptno,
       rank(1600) within group 
         (order by sal desc) rang,
       dense_rank(1600) within group 
         (order by sal desc) dense_rang
  from emp
 group by deptno;
  
-- Darstellung der Mitarbeiter nach Abteilung und Gehalt
select deptno, ename, job, sal
  from emp
 order by deptno, sal desc;
 
-- Verwendung der RANK-Funktion mit mehreren Parametern
select rank(1250, 900) within group 
         (order by sal desc, comm desc) rang
  from emp
 where job = 'SALESMAN';
 
select ename, sal, comm
  from emp
 where job = 'SALESMAN'
 order by sal desc, comm desc;
 
-- Verwendung der Funktionen FIRST und LAST
-- Als Benutzer SH ausfhren!
set timing on

select min(prod_id) keep
         (dense_rank first order by sum(amount_sold) desc) top_revenue, 
       min(prod_id) keep
         (dense_rank last order by sum(amount_sold) desc) flop_revenue, 
       min(prod_id) keep 
         (dense_rank first order by sum(quantity_sold) desc) top_seller, 
       min(prod_id) keep 
         (dense_rank last order by sum(quantity_sold) desc) flop_seller
  from sales 
 group by prod_id, channel_id;
 
-- Versuch, die PROD_ID und die maximale Umsatzsumme gleichzeitig zu erfragen:
select min(prod_id) keep
         (dense_rank first order by 
            sum(amount_sold) desc) prod_id,
       max(sum(amount_sold)) max_amount
  from sales 
 group by prod_id, channel_id;
 
-- Verwendung der Funktion LISTAGG
select deptno, 
       listagg (ename, ':') within group
         (order by ename) mitarbeiterliste
  from emp
 group by deptno;